YARP Tutorials                                                      {#tutorials}
==============

Here are a collection of tutorials on various topics in YARP.

Using YARP and CMake in your projects:
* \subpage yarp_cmake_hello

Using YARP ports for communication:
* \subpage note_ports
* \subpage port_expert
* \subpage carrier_config
* \subpage carrier_expert
* \subpage rpc_ports
* \subpage yarp_without_yarp
* \subpage persistent_connections
* \subpage port_admin
* \subpage yarp_port_auth
* \subpage yarp_without_nameserver
* \subpage yarp_with_ros
* \subpage yarp_http
* \subpage idls

Make sure you understand how to control YARP buffering policies the life-cycle of messages:

* \subpage yarp_buffering

How to write a standard module, search and install configuration files:
* \subpage yarp_resource_finder_tutorials
* \subpage yarp_rfmodule_tutorial

ROS types in YARP:
* \ref rostypes_tutorial_portable
* \ref rostypes_tutorial_continued

Using the Thrift IDL to define data types and interfaces:
* \ref thrift_tutorial_portable
* \ref thrift_tutorial_simple
* \ref thrift_tutorial
* \ref thrift_editor

Using YARP devices:
* \subpage note_devices
* \subpage yarpdev
* \subpage yarp_motor_control
* \subpage dev_examples
* \subpage add_a_plugin (older method: \ref add_a_device)
* \subpage yarp_config_files

More software tutorials:
* \subpage yarp_pointcloud
* \subpage yarp_code_examples
* \subpage using_cmake
* \subpage carrier_h264_howto

Communication protocol details:
* \subpage yarp_protocol
* \subpage data_rep
* \subpage name_server
* \subpage terms

YARP implementation:
* \subpage yarp_guts
* \subpage yarp_plugins

GUI tutorials:
* \subpage yarpdataplayer_example
* \subpage yarpdataplayer_rec_example
